/*     */ package org.apache.batik.gvt;
/*     */ 
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.Shape;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.lang.ref.WeakReference;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.apache.batik.ext.awt.image.renderable.Filter;
/*     */ import org.apache.batik.gvt.event.GraphicsNodeChangeAdapter;
/*     */ import org.apache.batik.gvt.event.GraphicsNodeChangeEvent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class UpdateTracker
/*     */   extends GraphicsNodeChangeAdapter
/*     */ {
/*  46 */   Map dirtyNodes = null;
/*  47 */   Map fromBounds = new HashMap();
/*  48 */   protected static Rectangle2D NULL_RECT = new Rectangle();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  57 */   public boolean hasChanged() { return (this.dirtyNodes != null); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List getDirtyAreas() {
/*  64 */     if (this.dirtyNodes == null) {
/*  65 */       return null;
/*     */     }
/*  67 */     List ret = new LinkedList();
/*  68 */     Set keys = this.dirtyNodes.keySet();
/*  69 */     Iterator i = keys.iterator();
/*  70 */     while (i.hasNext()) {
/*  71 */       WeakReference gnWRef = (WeakReference)i.next();
/*  72 */       GraphicsNode gn = (GraphicsNode)gnWRef.get();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/*  79 */       if (gn == null) {
/*     */         continue;
/*     */       }
/*  82 */       AffineTransform oat = (AffineTransform)this.dirtyNodes.get(gnWRef);
/*  83 */       if (oat != null) {
/*  84 */         oat = new AffineTransform(oat);
/*     */       }
/*     */       
/*  87 */       Rectangle2D srcORgn = (Rectangle2D)this.fromBounds.remove(gnWRef);
/*     */       
/*  89 */       Rectangle2D srcNRgn = null;
/*  90 */       AffineTransform nat = null;
/*  91 */       if (!(srcORgn instanceof ChngSrcRect)) {
/*     */         
/*  93 */         srcNRgn = gn.getBounds();
/*  94 */         nat = gn.getTransform();
/*  95 */         if (nat != null) {
/*  96 */           nat = new AffineTransform(nat);
/*     */         }
/*     */       } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/*     */       while (true) {
/* 111 */         gn = gn.getParent();
/* 112 */         if (gn == null) {
/*     */           break;
/*     */         }
/* 115 */         Filter f = gn.getFilter();
/* 116 */         if (f != null) {
/* 117 */           srcNRgn = f.getBounds2D();
/* 118 */           nat = null;
/*     */         } 
/*     */ 
/*     */         
/* 122 */         AffineTransform at = gn.getTransform();
/*     */         
/* 124 */         gnWRef = gn.getWeakReference();
/* 125 */         AffineTransform poat = (AffineTransform)this.dirtyNodes.get(gnWRef);
/* 126 */         if (poat == null) poat = at; 
/* 127 */         if (poat != null) {
/* 128 */           if (oat != null) {
/* 129 */             oat.preConcatenate(poat);
/*     */           } else {
/* 131 */             oat = new AffineTransform(poat);
/*     */           } 
/*     */         }
/* 134 */         if (at != null) {
/* 135 */           if (nat != null) {
/* 136 */             nat.preConcatenate(at); continue;
/*     */           } 
/* 138 */           nat = new AffineTransform(at);
/*     */         } 
/*     */       } 
/*     */       
/* 142 */       if (gn == null) {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         
/* 148 */         Shape oRgn = srcORgn;
/* 149 */         if (oRgn != null && oRgn != NULL_RECT) {
/* 150 */           if (oat != null) {
/* 151 */             oRgn = oat.createTransformedShape(srcORgn);
/*     */           }
/*     */           
/* 154 */           ret.add(oRgn);
/*     */         } 
/*     */         
/* 157 */         if (srcNRgn != null) {
/* 158 */           Shape nRgn = srcNRgn;
/* 159 */           if (nat != null)
/* 160 */             nRgn = nat.createTransformedShape(srcNRgn); 
/* 161 */           if (nRgn != null) {
/* 162 */             ret.add(nRgn);
/*     */           }
/*     */         } 
/*     */       } 
/*     */     } 
/* 167 */     this.fromBounds.clear();
/* 168 */     this.dirtyNodes.clear();
/* 169 */     return ret;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Rectangle2D getNodeDirtyRegion(GraphicsNode gn, AffineTransform at) {
/* 181 */     WeakReference gnWRef = gn.getWeakReference();
/* 182 */     AffineTransform nat = (AffineTransform)this.dirtyNodes.get(gnWRef);
/* 183 */     if (nat == null) nat = gn.getTransform(); 
/* 184 */     if (nat != null) {
/* 185 */       at = new AffineTransform(at);
/* 186 */       at.concatenate(nat);
/*     */     } 
/*     */     
/* 189 */     Filter f = gn.getFilter();
/* 190 */     Rectangle2D ret = null;
/* 191 */     if (gn instanceof CompositeGraphicsNode) {
/* 192 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/* 193 */       Iterator iter = cgn.iterator();
/*     */       
/* 195 */       while (iter.hasNext()) {
/* 196 */         GraphicsNode childGN = (GraphicsNode)iter.next();
/* 197 */         Rectangle2D r2d = getNodeDirtyRegion(childGN, at);
/* 198 */         if (r2d != null) {
/* 199 */           if (f != null) {
/*     */ 
/*     */             
/* 202 */             Shape s = at.createTransformedShape(f.getBounds2D());
/* 203 */             ret = s.getBounds2D();
/*     */             break;
/*     */           } 
/* 206 */           if (ret == null || ret == NULL_RECT) { ret = r2d; continue; }
/*     */           
/* 208 */           ret.add(r2d);
/*     */         } 
/*     */       } 
/*     */     } else {
/* 212 */       ret = (Rectangle2D)this.fromBounds.remove(gnWRef);
/* 213 */       if (ret == null) {
/* 214 */         if (f != null) { ret = f.getBounds2D(); }
/* 215 */         else { ret = gn.getBounds(); } 
/* 216 */       } else if (ret == NULL_RECT) {
/* 217 */         ret = null;
/* 218 */       }  if (ret != null)
/* 219 */         ret = at.createTransformedShape(ret).getBounds2D(); 
/*     */     } 
/* 221 */     return ret;
/*     */   }
/*     */ 
/*     */   
/* 225 */   public Rectangle2D getNodeDirtyRegion(GraphicsNode gn) { return getNodeDirtyRegion(gn, new AffineTransform()); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void changeStarted(GraphicsNodeChangeEvent gnce) {
/* 234 */     GraphicsNode gn = gnce.getGraphicsNode();
/* 235 */     WeakReference gnWRef = gn.getWeakReference();
/*     */     
/* 237 */     boolean doPut = false;
/* 238 */     if (this.dirtyNodes == null) {
/* 239 */       this.dirtyNodes = new HashMap();
/* 240 */       doPut = true;
/* 241 */     } else if (!this.dirtyNodes.containsKey(gnWRef)) {
/* 242 */       doPut = true;
/*     */     } 
/* 244 */     if (doPut) {
/* 245 */       AffineTransform at = gn.getTransform();
/* 246 */       if (at != null) { at = (AffineTransform)at.clone(); }
/* 247 */       else { at = new AffineTransform(); }
/* 248 */        this.dirtyNodes.put(gnWRef, at);
/*     */     } 
/*     */     
/* 251 */     GraphicsNode chngSrc = gnce.getChangeSrc();
/* 252 */     Rectangle2D rgn = null;
/* 253 */     if (chngSrc != null) {
/*     */ 
/*     */       
/* 256 */       Rectangle2D drgn = getNodeDirtyRegion(chngSrc);
/* 257 */       if (drgn != null) {
/* 258 */         rgn = new ChngSrcRect(this, drgn);
/*     */       }
/*     */     } else {
/* 261 */       rgn = gn.getBounds();
/*     */     } 
/*     */     
/* 264 */     Rectangle2D r2d = (Rectangle2D)this.fromBounds.remove(gnWRef);
/* 265 */     if (rgn != null) {
/* 266 */       if (r2d != null && r2d != NULL_RECT) {
/*     */ 
/*     */ 
/*     */ 
/*     */         
/* 271 */         r2d.add(rgn);
/*     */       } else {
/*     */         
/* 274 */         r2d = rgn;
/*     */       } 
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 283 */     if (r2d == null)
/* 284 */       r2d = NULL_RECT; 
/* 285 */     this.fromBounds.put(gnWRef, r2d);
/*     */   }
/*     */   
/*     */   class ChngSrcRect extends Rectangle2D.Float {
/*     */     ChngSrcRect(UpdateTracker this$0, Rectangle2D r2d) {
/* 290 */       super((float)r2d.getX(), (float)r2d.getY(), (float)r2d.getWidth(), (float)r2d.getHeight());
/*     */       this.this$0 = this$0;
/*     */     }
/*     */ 
/*     */     
/*     */     private final UpdateTracker this$0;
/*     */   }
/*     */ 
/*     */   
/* 299 */   public void clear() { this.dirtyNodes = null; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\UpdateTracker.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */