/*     */ package org.apache.batik.gvt.event;
/*     */ 
/*     */ import java.awt.Point;
/*     */ import java.awt.Toolkit;
/*     */ import java.awt.event.InputEvent;
/*     */ import java.awt.event.KeyEvent;
/*     */ import java.awt.event.KeyListener;
/*     */ import java.awt.event.MouseEvent;
/*     */ import java.awt.event.MouseListener;
/*     */ import java.awt.event.MouseMotionListener;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Point2D;
/*     */ import java.lang.reflect.Array;
/*     */ import java.util.EventListener;
/*     */ import java.util.EventObject;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import javax.swing.event.EventListenerList;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class AbstractAWTEventDispatcher
/*     */   implements EventDispatcher, MouseListener, MouseMotionListener, KeyListener
/*     */ {
/*     */   protected GraphicsNode root;
/*     */   protected AffineTransform baseTransform;
/*     */   protected EventListenerList glisteners;
/*     */   protected GraphicsNode lastHit;
/*     */   protected GraphicsNode currentKeyEventTarget;
/*  93 */   protected List eventQueue = new LinkedList();
/*     */   protected boolean eventDispatchEnabled = true;
/*  95 */   protected int eventQueueMaxSize = 10;
/*     */ 
/*     */   
/*     */   static final int MAX_QUEUE_SIZE = 10;
/*     */ 
/*     */   
/* 101 */   private int nodeIncrementEventID = 401;
/* 102 */   private int nodeIncrementEventCode = 9;
/* 103 */   private int nodeIncrementEventModifiers = 0;
/* 104 */   private int nodeDecrementEventID = 401;
/* 105 */   private int nodeDecrementEventCode = 9;
/* 106 */   private int nodeDecrementEventModifiers = 1;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setRootNode(GraphicsNode root) {
/* 120 */     if (this.root != root)
/* 121 */       this.eventQueue.clear(); 
/* 122 */     this.root = root;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 130 */   public GraphicsNode getRootNode() { return this.root; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setBaseTransform(AffineTransform t) {
/* 139 */     if (this.baseTransform != t && (this.baseTransform == null || !this.baseTransform.equals(t)))
/*     */     {
/*     */ 
/*     */       
/* 143 */       this.eventQueue.clear(); } 
/* 144 */     this.baseTransform = t;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 152 */   public AffineTransform getBaseTransform() { return new AffineTransform(this.baseTransform); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 165 */   public void mousePressed(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 174 */   public void mouseReleased(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 183 */   public void mouseEntered(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 192 */   public void mouseExited(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 201 */   public void mouseClicked(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 210 */   public void mouseMoved(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 219 */   public void mouseDragged(MouseEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 228 */   public void keyPressed(KeyEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 237 */   public void keyReleased(KeyEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 246 */   public void keyTyped(KeyEvent evt) { dispatchEvent(evt); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addGraphicsNodeMouseListener(GraphicsNodeMouseListener l) {
/* 259 */     if (this.glisteners == null) {
/* 260 */       this.glisteners = new EventListenerList();
/*     */     }
/* 262 */     this.glisteners.add(GraphicsNodeMouseListener.class, l);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void removeGraphicsNodeMouseListener(GraphicsNodeMouseListener l) {
/* 271 */     if (this.glisteners != null) {
/* 272 */       this.glisteners.remove(GraphicsNodeMouseListener.class, l);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addGraphicsNodeMouseWheelListener(GraphicsNodeMouseWheelListener l) {
/* 283 */     if (this.glisteners == null) {
/* 284 */       this.glisteners = new EventListenerList();
/*     */     }
/* 286 */     this.glisteners.add(GraphicsNodeMouseWheelListener.class, l);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void removeGraphicsNodeMouseWheelListener(GraphicsNodeMouseWheelListener l) {
/* 296 */     if (this.glisteners != null) {
/* 297 */       this.glisteners.remove(GraphicsNodeMouseWheelListener.class, l);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addGraphicsNodeKeyListener(GraphicsNodeKeyListener l) {
/* 307 */     if (this.glisteners == null) {
/* 308 */       this.glisteners = new EventListenerList();
/*     */     }
/* 310 */     this.glisteners.add(GraphicsNodeKeyListener.class, l);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void removeGraphicsNodeKeyListener(GraphicsNodeKeyListener l) {
/* 319 */     if (this.glisteners != null) {
/* 320 */       this.glisteners.remove(GraphicsNodeKeyListener.class, l);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public EventListener[] getListeners(Class listenerType) {
/* 334 */     Object array = Array.newInstance(listenerType, this.glisteners.getListenerCount(listenerType));
/*     */ 
/*     */     
/* 337 */     Object[] pairElements = this.glisteners.getListenerList();
/* 338 */     for (int i = 0, j = 0; i < pairElements.length - 1; i += 2) {
/* 339 */       if (pairElements[i].equals(listenerType)) {
/* 340 */         Array.set(array, j, pairElements[i + 1]);
/* 341 */         j++;
/*     */       } 
/*     */     } 
/* 344 */     return (EventListener[])array;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setEventDispatchEnabled(boolean b) {
/* 352 */     this.eventDispatchEnabled = b;
/* 353 */     if (this.eventDispatchEnabled)
/*     */     {
/* 355 */       while (this.eventQueue.size() > 0) {
/* 356 */         EventObject evt = (EventObject)this.eventQueue.remove(0);
/* 357 */         dispatchEvent(evt);
/*     */       }  } 
/*     */   }
/*     */   
/*     */   public void setEventQueueMaxSize(int n) {
/* 362 */     this.eventQueueMaxSize = n;
/* 363 */     if (n == 0) this.eventQueue.clear();
/*     */     
/* 365 */     while (this.eventQueue.size() > this.eventQueueMaxSize) {
/* 366 */       this.eventQueue.remove(0);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void dispatchEvent(EventObject evt) {
/* 374 */     if (this.root == null)
/*     */       return; 
/* 376 */     if (!this.eventDispatchEnabled) {
/* 377 */       if (this.eventQueueMaxSize > 0) {
/* 378 */         this.eventQueue.add(evt);
/* 379 */         while (this.eventQueue.size() > this.eventQueueMaxSize)
/*     */         {
/*     */           
/* 382 */           this.eventQueue.remove(0); } 
/*     */       } 
/*     */       return;
/*     */     } 
/* 386 */     if (evt instanceof MouseEvent) {
/* 387 */       dispatchMouseEvent((MouseEvent)evt);
/* 388 */     } else if (evt instanceof KeyEvent) {
/* 389 */       InputEvent e = (InputEvent)evt;
/* 390 */       if (isNodeIncrementEvent(e)) {
/* 391 */         incrementKeyTarget();
/* 392 */       } else if (isNodeDecrementEvent(e)) {
/* 393 */         decrementKeyTarget();
/*     */       } else {
/* 395 */         dispatchKeyEvent((KeyEvent)evt);
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected int getCurrentLockState() {
/* 404 */     Toolkit t = Toolkit.getDefaultToolkit();
/* 405 */     int lockState = 0;
/*     */     try {
/* 407 */       if (t.getLockingKeyState(262)) {
/* 408 */         lockState++;
/*     */       }
/* 410 */     } catch (UnsupportedOperationException ex) {}
/*     */     
/* 412 */     lockState <<= 1;
/*     */     try {
/* 414 */       if (t.getLockingKeyState(145)) {
/* 415 */         lockState++;
/*     */       }
/* 417 */     } catch (UnsupportedOperationException ex) {}
/*     */     
/* 419 */     lockState <<= 1;
/*     */     try {
/* 421 */       if (t.getLockingKeyState(144)) {
/* 422 */         lockState++;
/*     */       }
/* 424 */     } catch (UnsupportedOperationException ex) {}
/*     */     
/* 426 */     lockState <<= 1;
/*     */     try {
/* 428 */       if (t.getLockingKeyState(20)) {
/* 429 */         lockState++;
/*     */       }
/* 431 */     } catch (UnsupportedOperationException ex) {}
/*     */     
/* 433 */     return lockState;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void dispatchMouseEvent(MouseEvent evt) {
/*     */     Point point;
/* 464 */     Point2D p = new Point2D.Float(evt.getX(), evt.getY());
/* 465 */     Point2D gnp = p;
/* 466 */     if (this.baseTransform != null) {
/* 467 */       gnp = this.baseTransform.transform(p, null);
/*     */     }
/*     */     
/* 470 */     GraphicsNode node = this.root.nodeHitAt(gnp);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 475 */     if (!evt.getComponent().isShowing()) {
/* 476 */       point = new Point(0, 0);
/*     */     } else {
/* 478 */       point = evt.getComponent().getLocationOnScreen();
/* 479 */       point.x += evt.getX();
/* 480 */       point.y += evt.getY();
/*     */     } 
/*     */     
/* 483 */     int currentLockState = getCurrentLockState();
/*     */     
/* 485 */     if (this.lastHit != node) {
/*     */       
/* 487 */       if (this.lastHit != null) {
/* 488 */         GraphicsNodeMouseEvent gvtevt = new GraphicsNodeMouseEvent(this.lastHit, 505, evt.getWhen(), getModifiers(evt), currentLockState, getButton(evt), (float)gnp.getX(), (float)gnp.getY(), (int)Math.floor(p.getX()), (int)Math.floor(p.getY()), point.x, point.y, evt.getClickCount(), node);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         
/* 503 */         processMouseEvent(gvtevt);
/*     */       } 
/*     */ 
/*     */       
/* 507 */       if (node != null) {
/* 508 */         GraphicsNodeMouseEvent graphicsNodeMouseEvent = new GraphicsNodeMouseEvent(node, 504, evt.getWhen(), getModifiers(evt), currentLockState, getButton(evt), (float)gnp.getX(), (float)gnp.getY(), (int)Math.floor(p.getX()), (int)Math.floor(p.getY()), point.x, point.y, evt.getClickCount(), this.lastHit);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         
/* 523 */         processMouseEvent(graphicsNodeMouseEvent);
/*     */       } 
/*     */     } 
/*     */ 
/*     */     
/* 528 */     if (node != null) {
/* 529 */       GraphicsNodeMouseEvent graphicsNodeMouseEvent = new GraphicsNodeMouseEvent(node, evt.getID(), evt.getWhen(), getModifiers(evt), currentLockState, getButton(evt), (float)gnp.getX(), (float)gnp.getY(), (int)Math.floor(p.getX()), (int)Math.floor(p.getY()), point.x, point.y, evt.getClickCount(), null);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 545 */       processMouseEvent(graphicsNodeMouseEvent);
/*     */     }
/*     */     else {
/*     */       
/* 549 */       GraphicsNodeMouseEvent graphicsNodeMouseEvent = new GraphicsNodeMouseEvent(this.root, evt.getID(), evt.getWhen(), getModifiers(evt), currentLockState, getButton(evt), (float)gnp.getX(), (float)gnp.getY(), (int)Math.floor(p.getX()), (int)Math.floor(p.getY()), point.x, point.y, evt.getClickCount(), null);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 564 */       processMouseEvent(graphicsNodeMouseEvent);
/*     */     } 
/* 566 */     this.lastHit = node;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void processMouseEvent(GraphicsNodeMouseEvent evt) {
/* 575 */     if (this.glisteners != null) {
/* 576 */       int i, i, i, i, i, i, i; GraphicsNodeMouseListener[] listeners = (GraphicsNodeMouseListener[])getListeners(GraphicsNodeMouseListener.class);
/*     */ 
/*     */       
/* 579 */       switch (evt.getID()) {
/*     */         case 503:
/* 581 */           for (i = 0; i < listeners.length; i++) {
/* 582 */             listeners[i].mouseMoved(evt);
/*     */           }
/*     */           return;
/*     */         case 506:
/* 586 */           for (i = 0; i < listeners.length; i++) {
/* 587 */             listeners[i].mouseDragged(evt);
/*     */           }
/*     */           return;
/*     */         case 504:
/* 591 */           for (i = 0; i < listeners.length; i++) {
/* 592 */             listeners[i].mouseEntered(evt);
/*     */           }
/*     */           return;
/*     */         case 505:
/* 596 */           for (i = 0; i < listeners.length; i++) {
/* 597 */             listeners[i].mouseExited(evt);
/*     */           }
/*     */           return;
/*     */         case 500:
/* 601 */           for (i = 0; i < listeners.length; i++) {
/* 602 */             listeners[i].mouseClicked(evt);
/*     */           }
/*     */           return;
/*     */         case 501:
/* 606 */           for (i = 0; i < listeners.length; i++) {
/* 607 */             listeners[i].mousePressed(evt);
/*     */           }
/*     */           return;
/*     */         case 502:
/* 611 */           for (i = 0; i < listeners.length; i++) {
/* 612 */             listeners[i].mouseReleased(evt);
/*     */           }
/*     */           return;
/*     */       } 
/* 616 */       throw new IllegalArgumentException("Unknown Mouse Event type: " + evt.getID());
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void processKeyEvent(GraphicsNodeKeyEvent evt) {
/* 628 */     if (this.glisteners != null) {
/* 629 */       int i, i, i; GraphicsNodeKeyListener[] listeners = (GraphicsNodeKeyListener[])getListeners(GraphicsNodeKeyListener.class);
/*     */ 
/*     */ 
/*     */       
/* 633 */       switch (evt.getID()) {
/*     */         case 401:
/* 635 */           for (i = 0; i < listeners.length; i++) {
/* 636 */             listeners[i].keyPressed(evt);
/*     */           }
/*     */           break;
/*     */         case 402:
/* 640 */           for (i = 0; i < listeners.length; i++) {
/* 641 */             listeners[i].keyReleased(evt);
/*     */           }
/*     */           break;
/*     */         case 400:
/* 645 */           for (i = 0; i < listeners.length; i++) {
/* 646 */             listeners[i].keyTyped(evt);
/*     */           }
/*     */           break;
/*     */         default:
/* 650 */           throw new IllegalArgumentException("Unknown Key Event type: " + evt.getID());
/*     */       } 
/*     */     } 
/* 653 */     evt.consume();
/*     */   }
/*     */ 
/*     */ 
/*     */   
/* 658 */   private void incrementKeyTarget() { throw new UnsupportedOperationException("Increment not implemented."); }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 663 */   private void decrementKeyTarget() { throw new UnsupportedOperationException("Decrement not implemented."); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setNodeIncrementEvent(InputEvent e) {
/* 671 */     this.nodeIncrementEventID = e.getID();
/* 672 */     if (e instanceof KeyEvent) {
/* 673 */       this.nodeIncrementEventCode = ((KeyEvent)e).getKeyCode();
/*     */     }
/* 675 */     this.nodeIncrementEventModifiers = e.getModifiers();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setNodeDecrementEvent(InputEvent e) {
/* 685 */     this.nodeDecrementEventID = e.getID();
/* 686 */     if (e instanceof KeyEvent) {
/* 687 */       this.nodeDecrementEventCode = ((KeyEvent)e).getKeyCode();
/*     */     }
/* 689 */     this.nodeDecrementEventModifiers = e.getModifiers();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected boolean isNodeIncrementEvent(InputEvent e) {
/* 704 */     if (e.getID() != this.nodeIncrementEventID)
/*     */     {
/* 706 */       return false;
/*     */     }
/*     */     
/* 709 */     if (e instanceof KeyEvent && (
/* 710 */       (KeyEvent)e).getKeyCode() != this.nodeIncrementEventCode)
/*     */     {
/* 712 */       return false;
/*     */     }
/*     */ 
/*     */     
/* 716 */     if ((e.getModifiers() & this.nodeIncrementEventModifiers) == 0)
/*     */     {
/* 718 */       return false;
/*     */     }
/*     */ 
/*     */     
/* 722 */     return true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected boolean isNodeDecrementEvent(InputEvent e) {
/* 736 */     if (e.getID() != this.nodeDecrementEventID)
/*     */     {
/* 738 */       return false;
/*     */     }
/*     */     
/* 741 */     if (e instanceof KeyEvent && (
/* 742 */       (KeyEvent)e).getKeyCode() != this.nodeDecrementEventCode)
/*     */     {
/* 744 */       return false;
/*     */     }
/*     */ 
/*     */     
/* 748 */     if ((e.getModifiers() & this.nodeDecrementEventModifiers) == 0)
/*     */     {
/* 750 */       return false;
/*     */     }
/*     */ 
/*     */     
/* 754 */     return true;
/*     */   }
/*     */   
/*     */   protected abstract void dispatchKeyEvent(KeyEvent paramKeyEvent);
/*     */   
/*     */   protected abstract int getModifiers(InputEvent paramInputEvent);
/*     */   
/*     */   protected abstract int getButton(MouseEvent paramMouseEvent);
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\event\AbstractAWTEventDispatcher.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */