/*     */ package org.apache.batik.gvt.event;
/*     */ 
/*     */ import java.awt.event.InputEvent;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class GraphicsNodeInputEvent
/*     */   extends GraphicsNodeEvent
/*     */ {
/*     */   public static final int SHIFT_MASK = 1;
/*     */   public static final int CTRL_MASK = 2;
/*     */   public static final int META_MASK = 4;
/*     */   public static final int ALT_MASK = 8;
/*     */   public static final int ALT_GRAPH_MASK = 32;
/*     */   public static final int BUTTON1_MASK = 1024;
/*     */   public static final int BUTTON2_MASK = 2048;
/*     */   public static final int BUTTON3_MASK = 4096;
/*     */   public static final int CAPS_LOCK_MASK = 1;
/*     */   public static final int NUM_LOCK_MASK = 2;
/*     */   public static final int SCROLL_LOCK_MASK = 4;
/*     */   public static final int KANA_LOCK_MASK = 8;
/*     */   long when;
/*     */   int modifiers;
/*     */   int lockState;
/*     */   
/*     */   protected GraphicsNodeInputEvent(GraphicsNode source, int id, long when, int modifiers, int lockState) {
/* 121 */     super(source, id);
/* 122 */     this.when = when;
/* 123 */     this.modifiers = modifiers;
/* 124 */     this.lockState = lockState;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected GraphicsNodeInputEvent(GraphicsNode source, InputEvent evt, int lockState) {
/* 135 */     super(source, evt.getID());
/* 136 */     this.when = evt.getWhen();
/* 137 */     this.modifiers = evt.getModifiers();
/* 138 */     this.lockState = lockState;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 145 */   public boolean isShiftDown() { return ((this.modifiers & true) != 0); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 152 */   public boolean isControlDown() { return ((this.modifiers & 0x2) != 0); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 159 */   public boolean isMetaDown() { return AWTEventDispatcher.isMetaDown(this.modifiers); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 166 */   public boolean isAltDown() { return ((this.modifiers & 0x8) != 0); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 173 */   public boolean isAltGraphDown() { return ((this.modifiers & 0x20) != 0); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 180 */   public long getWhen() { return this.when; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 187 */   public int getModifiers() { return this.modifiers; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 194 */   public int getLockState() { return this.lockState; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\event\GraphicsNodeInputEvent.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */