/*     */ package org.apache.batik.gvt.filter;
/*     */ 
/*     */ import java.awt.Shape;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.NoninvertibleTransformException;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.awt.image.RenderedImage;
/*     */ import java.awt.image.renderable.RenderContext;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import org.apache.batik.ext.awt.image.CompositeRule;
/*     */ import org.apache.batik.ext.awt.image.PadMode;
/*     */ import org.apache.batik.ext.awt.image.renderable.AbstractRable;
/*     */ import org.apache.batik.ext.awt.image.renderable.AffineRable8Bit;
/*     */ import org.apache.batik.ext.awt.image.renderable.CompositeRable8Bit;
/*     */ import org.apache.batik.ext.awt.image.renderable.Filter;
/*     */ import org.apache.batik.ext.awt.image.renderable.PadRable8Bit;
/*     */ import org.apache.batik.gvt.CompositeGraphicsNode;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BackgroundRable8Bit
/*     */   extends AbstractRable
/*     */ {
/*     */   private GraphicsNode node;
/*     */   
/*  61 */   public GraphicsNode getGraphicsNode() { return this.node; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setGraphicsNode(GraphicsNode node) {
/*  68 */     if (node == null) {
/*  69 */       throw new IllegalArgumentException();
/*     */     }
/*     */     
/*  72 */     this.node = node;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public BackgroundRable8Bit(GraphicsNode node) {
/*  79 */     if (node == null) {
/*  80 */       throw new IllegalArgumentException();
/*     */     }
/*  82 */     this.node = node;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   static Rectangle2D addBounds(CompositeGraphicsNode cgn, GraphicsNode child, Rectangle2D init) {
/*  95 */     List children = cgn.getChildren();
/*  96 */     Iterator i = children.iterator();
/*  97 */     Rectangle2D r2d = null;
/*  98 */     while (i.hasNext()) {
/*  99 */       GraphicsNode gn = (GraphicsNode)i.next();
/* 100 */       if (gn == child) {
/*     */         break;
/*     */       }
/*     */       
/* 104 */       Rectangle2D cr2d = gn.getBounds();
/* 105 */       AffineTransform at = gn.getTransform();
/* 106 */       if (at != null) {
/* 107 */         cr2d = at.createTransformedShape(cr2d).getBounds2D();
/*     */       }
/* 109 */       if (r2d == null) { r2d = (Rectangle2D)cr2d.clone(); continue; }
/* 110 */        r2d.add(cr2d);
/*     */     } 
/*     */     
/* 113 */     if (r2d == null) {
/* 114 */       if (init == null) {
/* 115 */         return CompositeGraphicsNode.VIEWPORT;
/*     */       }
/* 117 */       return init;
/*     */     } 
/*     */     
/* 120 */     if (init == null) {
/* 121 */       return r2d;
/*     */     }
/* 123 */     init.add(r2d);
/*     */     
/* 125 */     return init;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   static Rectangle2D getViewportBounds(GraphicsNode gn, GraphicsNode child) {
/* 132 */     Rectangle2D r2d = null;
/* 133 */     if (gn instanceof CompositeGraphicsNode) {
/* 134 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/* 135 */       r2d = cgn.getBackgroundEnable();
/*     */     } 
/*     */     
/* 138 */     if (r2d == null)
/*     */     {
/* 140 */       r2d = getViewportBounds(gn.getParent(), gn);
/*     */     }
/*     */     
/* 143 */     if (r2d == null) {
/* 144 */       return null;
/*     */     }
/*     */     
/* 147 */     if (r2d == CompositeGraphicsNode.VIEWPORT) {
/*     */       
/* 149 */       if (child == null) {
/* 150 */         return (Rectangle2D)gn.getPrimitiveBounds().clone();
/*     */       }
/*     */ 
/*     */       
/* 154 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/* 155 */       return addBounds(cgn, child, null);
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 160 */     AffineTransform at = gn.getTransform();
/* 161 */     if (at != null) {
/*     */       try {
/* 163 */         at = at.createInverse();
/* 164 */         r2d = at.createTransformedShape(r2d).getBounds2D();
/*     */       } catch (NoninvertibleTransformException nte) {
/*     */         
/* 167 */         r2d = null;
/*     */       } 
/*     */     }
/*     */     
/* 171 */     if (child != null) {
/*     */       
/* 173 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/* 174 */       r2d = addBounds(cgn, child, r2d);
/*     */     } else {
/* 176 */       Rectangle2D gnb = gn.getPrimitiveBounds();
/* 177 */       if (gnb != null) {
/* 178 */         r2d.add(gnb);
/*     */       }
/*     */     } 
/* 181 */     return r2d;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   static Rectangle2D getBoundsRecursive(GraphicsNode gn, GraphicsNode child) {
/* 190 */     Rectangle2D r2d = null;
/* 191 */     if (gn == null)
/*     */     {
/* 193 */       return null;
/*     */     }
/*     */     
/* 196 */     if (gn instanceof CompositeGraphicsNode) {
/* 197 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/*     */       
/* 199 */       r2d = cgn.getBackgroundEnable();
/*     */     } 
/*     */ 
/*     */     
/* 203 */     if (r2d != null) {
/* 204 */       return r2d;
/*     */     }
/*     */     
/* 207 */     r2d = getBoundsRecursive(gn.getParent(), gn);
/*     */ 
/*     */     
/* 210 */     if (r2d == null)
/*     */     {
/* 212 */       return new Rectangle2D.Float(0.0F, 0.0F, 0.0F, 0.0F);
/*     */     }
/*     */ 
/*     */ 
/*     */     
/* 217 */     if (r2d == CompositeGraphicsNode.VIEWPORT) {
/* 218 */       return r2d;
/*     */     }
/* 220 */     AffineTransform at = gn.getTransform();
/* 221 */     if (at != null) {
/*     */       
/*     */       try {
/*     */         
/* 225 */         at = at.createInverse();
/* 226 */         r2d = at.createTransformedShape(r2d).getBounds2D();
/*     */       } catch (NoninvertibleTransformException nte) {
/*     */         
/* 229 */         r2d = null;
/*     */       } 
/*     */     }
/*     */     
/* 233 */     return r2d;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Rectangle2D getBounds2D() {
/* 241 */     Rectangle2D r2d = getBoundsRecursive(this.node, null);
/*     */ 
/*     */ 
/*     */     
/* 245 */     if (r2d == CompositeGraphicsNode.VIEWPORT) {
/* 246 */       r2d = getViewportBounds(this.node, null);
/*     */     }
/*     */ 
/*     */     
/* 250 */     return r2d;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Filter getBackground(GraphicsNode gn, GraphicsNode child, Rectangle2D aoi) {
/* 265 */     if (gn == null) {
/* 266 */       throw new IllegalArgumentException("BackgroundImage requested yet no parent has 'enable-background:new'");
/*     */     }
/*     */ 
/*     */ 
/*     */     
/* 271 */     Rectangle2D r2d = null;
/* 272 */     if (gn instanceof CompositeGraphicsNode) {
/* 273 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/* 274 */       r2d = cgn.getBackgroundEnable();
/*     */     } 
/*     */     
/* 277 */     List srcs = new ArrayList();
/* 278 */     if (r2d == null) {
/* 279 */       Rectangle2D paoi = aoi;
/* 280 */       AffineTransform at = gn.getTransform();
/* 281 */       if (at != null)
/* 282 */         paoi = at.createTransformedShape(aoi).getBounds2D(); 
/* 283 */       Filter f = getBackground(gn.getParent(), gn, paoi);
/*     */ 
/*     */       
/* 286 */       if (f != null && f.getBounds2D().intersects(aoi)) {
/* 287 */         srcs.add(f);
/*     */       }
/*     */     } 
/*     */     
/* 291 */     if (child != null) {
/* 292 */       CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn;
/* 293 */       List children = cgn.getChildren();
/* 294 */       Iterator i = children.iterator();
/* 295 */       while (i.hasNext()) {
/* 296 */         GraphicsNode childGN = (GraphicsNode)i.next();
/*     */ 
/*     */ 
/*     */         
/* 300 */         if (childGN == child) {
/*     */           break;
/*     */         }
/* 303 */         Rectangle2D cbounds = childGN.getBounds();
/*     */ 
/*     */ 
/*     */ 
/*     */         
/* 308 */         AffineTransform at = childGN.getTransform();
/* 309 */         if (at != null) {
/* 310 */           cbounds = at.createTransformedShape(cbounds).getBounds2D();
/*     */         }
/*     */         
/* 313 */         if (aoi.intersects(cbounds)) {
/* 314 */           srcs.add(childGN.getEnableBackgroundGraphicsNodeRable(true));
/*     */         }
/*     */       } 
/*     */     } 
/*     */ 
/*     */     
/* 320 */     if (srcs.size() == 0) {
/* 321 */       return null;
/*     */     }
/* 323 */     CompositeRable8Bit compositeRable8Bit = null;
/* 324 */     if (srcs.size() == 1) {
/* 325 */       compositeRable8Bit = (Filter)srcs.get(0);
/*     */     } else {
/* 327 */       compositeRable8Bit = new CompositeRable8Bit(srcs, CompositeRule.OVER, false);
/*     */     } 
/* 329 */     if (child != null) {
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 334 */       AffineTransform at = child.getTransform();
/* 335 */       if (at != null) {
/*     */         try {
/* 337 */           at = at.createInverse();
/* 338 */           AffineRable8Bit affineRable8Bit = new AffineRable8Bit(compositeRable8Bit, at);
/*     */         } catch (NoninvertibleTransformException nte) {
/* 340 */           compositeRable8Bit = null;
/*     */         } 
/*     */       }
/*     */     } 
/*     */     
/* 345 */     return compositeRable8Bit;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 356 */   public boolean isDynamic() { return false; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public RenderedImage createRendering(RenderContext renderContext) {
/* 376 */     Rectangle2D r2d = getBounds2D();
/*     */ 
/*     */ 
/*     */     
/* 380 */     Shape aoi = renderContext.getAreaOfInterest();
/* 381 */     if (aoi != null) {
/* 382 */       Rectangle2D aoiR2d = aoi.getBounds2D();
/*     */ 
/*     */ 
/*     */       
/* 386 */       if (!r2d.intersects(aoiR2d)) {
/* 387 */         return null;
/*     */       }
/* 389 */       Rectangle2D.intersect(r2d, aoiR2d, r2d);
/*     */     } 
/*     */     
/* 392 */     Filter background = getBackground(this.node, null, r2d);
/*     */     
/* 394 */     if (background == null) {
/* 395 */       return null;
/*     */     }
/* 397 */     PadRable8Bit padRable8Bit = new PadRable8Bit(background, r2d, PadMode.ZERO_PAD);
/*     */ 
/*     */     
/* 400 */     return padRable8Bit.createRendering(new RenderContext(renderContext.getTransform(), r2d, renderContext.getRenderingHints()));
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\filter\BackgroundRable8Bit.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */