/*     */ package org.apache.batik.gvt.filter;
/*     */ 
/*     */ import java.awt.AlphaComposite;
/*     */ import java.awt.Graphics2D;
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.RenderingHints;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.awt.image.BufferedImage;
/*     */ import java.awt.image.ColorModel;
/*     */ import java.awt.image.SampleModel;
/*     */ import java.awt.image.WritableRaster;
/*     */ import org.apache.batik.ext.awt.image.GraphicsUtil;
/*     */ import org.apache.batik.ext.awt.image.rendered.AbstractRed;
/*     */ import org.apache.batik.ext.awt.image.rendered.AbstractTiledRed;
/*     */ import org.apache.batik.ext.awt.image.rendered.CachableRed;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GraphicsNodeRed8Bit
/*     */   extends AbstractRed
/*     */ {
/*     */   private GraphicsNode node;
/*     */   private AffineTransform node2dev;
/*     */   private RenderingHints hints;
/*     */   private boolean usePrimitivePaint;
/*     */   
/*     */   public GraphicsNodeRed8Bit(GraphicsNode node, AffineTransform node2dev, boolean usePrimitivePaint, RenderingHints hints) {
/*  64 */     this.node = node;
/*  65 */     this.node2dev = node2dev;
/*  66 */     this.hints = hints;
/*  67 */     this.usePrimitivePaint = usePrimitivePaint;
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  72 */     AffineTransform at = node2dev;
/*  73 */     Rectangle2D bounds2D = node.getPrimitiveBounds();
/*  74 */     if (bounds2D == null) bounds2D = new Rectangle2D.Float(0.0F, 0.0F, 1.0F, 1.0F); 
/*  75 */     if (!usePrimitivePaint) {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/*  82 */       AffineTransform nodeAt = node.getTransform();
/*  83 */       if (nodeAt != null) {
/*  84 */         at = (AffineTransform)at.clone();
/*  85 */         at.concatenate(nodeAt);
/*     */       } 
/*     */     } 
/*  88 */     Rectangle bounds = at.createTransformedShape(bounds2D).getBounds();
/*     */ 
/*     */     
/*  91 */     ColorModel cm = createColorModel();
/*     */     
/*  93 */     int defSz = AbstractTiledRed.getDefaultTileSize();
/*     */ 
/*     */     
/*  96 */     int tgX = defSz * (int)Math.floor((bounds.x / defSz));
/*  97 */     int tgY = defSz * (int)Math.floor((bounds.y / defSz));
/*     */     
/*  99 */     int tw = bounds.x + bounds.width - tgX;
/* 100 */     if (tw > defSz) tw = defSz; 
/* 101 */     int th = bounds.y + bounds.height - tgY;
/* 102 */     if (th > defSz) th = defSz; 
/* 103 */     if (tw <= 0 || th <= 0) {
/* 104 */       tw = 1;
/* 105 */       th = 1;
/*     */     } 
/*     */ 
/*     */     
/* 109 */     SampleModel sm = cm.createCompatibleSampleModel(tw, th);
/*     */ 
/*     */     
/* 112 */     init((CachableRed)null, bounds, cm, sm, tgX, tgY, null);
/*     */   }
/*     */   
/*     */   public WritableRaster copyData(WritableRaster wr) {
/* 116 */     genRect(wr);
/* 117 */     return wr;
/*     */   }
/*     */ 
/*     */   
/*     */   public void genRect(WritableRaster wr) {
/* 122 */     BufferedImage offScreen = new BufferedImage(this.cm, wr.createWritableTranslatedChild(0, 0), this.cm.isAlphaPremultiplied(), null);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 128 */     Graphics2D g = GraphicsUtil.createGraphics(offScreen, this.hints);
/* 129 */     g.setComposite(AlphaComposite.Clear);
/* 130 */     g.fillRect(0, 0, wr.getWidth(), wr.getHeight());
/* 131 */     g.setComposite(AlphaComposite.SrcOver);
/* 132 */     g.translate(-wr.getMinX(), -wr.getMinY());
/*     */ 
/*     */     
/* 135 */     g.transform(this.node2dev);
/*     */ 
/*     */ 
/*     */     
/* 139 */     if (this.usePrimitivePaint) {
/* 140 */       this.node.primitivePaint(g);
/*     */     } else {
/*     */       
/* 143 */       this.node.paint(g);
/*     */     } 
/*     */     
/* 146 */     g.dispose();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 152 */   static final boolean onMacOSX = "Mac OS X".equals(System.getProperty("os.name"));
/*     */ 
/*     */   
/*     */   public ColorModel createColorModel() {
/* 156 */     if (onMacOSX)
/* 157 */       return GraphicsUtil.sRGB_Pre; 
/* 158 */     return GraphicsUtil.sRGB_Unpre;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\filter\GraphicsNodeRed8Bit.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */