/*     */ package org.apache.batik.gvt.flow;
/*     */ 
/*     */ import java.awt.font.FontRenderContext;
/*     */ import java.awt.font.TextAttribute;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.batik.gvt.font.GVTFont;
/*     */ import org.apache.batik.gvt.font.GVTLineMetrics;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BlockInfo
/*     */ {
/*     */   public static final int ALIGN_START = 0;
/*     */   public static final int ALIGN_MIDDLE = 1;
/*     */   public static final int ALIGN_END = 2;
/*     */   public static final int ALIGN_FULL = 3;
/*     */   protected float top;
/*     */   protected float right;
/*     */   protected float bottom;
/*     */   protected float left;
/*     */   protected float indent;
/*     */   protected int alignment;
/*     */   protected float lineHeight;
/*     */   protected List fontList;
/*     */   protected Map fontAttrs;
/*     */   protected float ascent;
/*     */   protected float descent;
/*     */   protected boolean flowRegionBreak;
/*     */   
/*     */   public BlockInfo(float top, float right, float bottom, float left, float indent, int alignment, float lineHeight, List fontList, Map fontAttrs, boolean flowRegionBreak) {
/*  52 */     this.ascent = -1.0F;
/*  53 */     this.descent = -1.0F;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  62 */     this.top = top;
/*  63 */     this.right = right;
/*  64 */     this.bottom = bottom;
/*  65 */     this.left = left;
/*     */     
/*  67 */     this.indent = indent;
/*     */     
/*  69 */     this.alignment = alignment;
/*     */     
/*  71 */     this.lineHeight = lineHeight;
/*  72 */     this.fontList = fontList;
/*  73 */     this.fontAttrs = fontAttrs;
/*     */     
/*  75 */     this.flowRegionBreak = flowRegionBreak;
/*     */   } public BlockInfo(float margin, int alignment) {
/*     */     this.ascent = -1.0F;
/*     */     this.descent = -1.0F;
/*  79 */     setMargin(margin);
/*  80 */     this.indent = 0.0F;
/*  81 */     this.alignment = alignment;
/*  82 */     this.flowRegionBreak = false;
/*     */   }
/*     */   
/*     */   public void setMargin(float margin) {
/*  86 */     this.top = margin;
/*  87 */     this.right = margin;
/*  88 */     this.bottom = margin;
/*  89 */     this.left = margin;
/*     */   }
/*     */   
/*     */   public void initLineInfo(FontRenderContext frc) {
/*  93 */     float fontSize = 12.0F;
/*  94 */     Float fsFloat = (Float)this.fontAttrs.get(TextAttribute.SIZE);
/*  95 */     if (fsFloat != null) {
/*  96 */       fontSize = fsFloat.floatValue();
/*     */     }
/*  98 */     Iterator i = this.fontList.iterator();
/*  99 */     if (i.hasNext()) {
/* 100 */       GVTFont font = (GVTFont)i.next();
/* 101 */       GVTLineMetrics lm = font.getLineMetrics("", frc);
/* 102 */       this.ascent = lm.getAscent();
/* 103 */       this.descent = lm.getDescent();
/*     */     } 
/*     */     
/* 106 */     if (this.ascent == -1.0F) {
/* 107 */       this.ascent = fontSize * 0.8F;
/* 108 */       this.descent = fontSize * 0.2F;
/*     */     } 
/*     */   }
/*     */   
/* 112 */   public float getTopMargin() { return this.top; }
/* 113 */   public float getRightMargin() { return this.right; }
/* 114 */   public float getBottomMargin() { return this.bottom; }
/* 115 */   public float getLeftMargin() { return this.left; }
/*     */   
/* 117 */   public float getIndent() { return this.indent; }
/*     */   
/* 119 */   public int getTextAlignment() { return this.alignment; }
/*     */ 
/*     */   
/* 122 */   public float getLineHeight() { return this.lineHeight; }
/* 123 */   public List getFontList() { return this.fontList; }
/* 124 */   public Map getFontAttrs() { return this.fontAttrs; }
/* 125 */   public float getAscent() { return this.ascent; }
/* 126 */   public float getDescent() { return this.descent; }
/*     */   
/* 128 */   public boolean isFlowRegionBreak() { return this.flowRegionBreak; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\flow\BlockInfo.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */