/*     */ package org.apache.batik.gvt.font;
/*     */ 
/*     */ import java.awt.font.LineMetrics;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GVTLineMetrics
/*     */ {
/*     */   protected float ascent;
/*     */   protected int baselineIndex;
/*     */   protected float[] baselineOffsets;
/*     */   protected float descent;
/*     */   protected float height;
/*     */   protected float leading;
/*     */   protected int numChars;
/*     */   protected float strikethroughOffset;
/*     */   protected float strikethroughThickness;
/*     */   protected float underlineOffset;
/*     */   protected float underlineThickness;
/*     */   protected float overlineOffset;
/*     */   protected float overlineThickness;
/*     */   
/*     */   public GVTLineMetrics(LineMetrics lineMetrics) {
/*  52 */     this.ascent = lineMetrics.getAscent();
/*  53 */     this.baselineIndex = lineMetrics.getBaselineIndex();
/*  54 */     this.baselineOffsets = lineMetrics.getBaselineOffsets();
/*  55 */     this.descent = lineMetrics.getDescent();
/*  56 */     this.height = lineMetrics.getHeight();
/*  57 */     this.leading = lineMetrics.getLeading();
/*  58 */     this.numChars = lineMetrics.getNumChars();
/*  59 */     this.strikethroughOffset = lineMetrics.getStrikethroughOffset();
/*  60 */     this.strikethroughThickness = lineMetrics.getStrikethroughThickness();
/*  61 */     this.underlineOffset = lineMetrics.getUnderlineOffset();
/*  62 */     this.underlineThickness = lineMetrics.getUnderlineThickness();
/*  63 */     this.overlineOffset = -this.ascent;
/*  64 */     this.overlineThickness = this.underlineThickness;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GVTLineMetrics(LineMetrics lineMetrics, float scaleFactor) {
/*  77 */     this.ascent = lineMetrics.getAscent() * scaleFactor;
/*  78 */     this.baselineIndex = lineMetrics.getBaselineIndex();
/*  79 */     this.baselineOffsets = lineMetrics.getBaselineOffsets();
/*  80 */     for (int i = 0; i < this.baselineOffsets.length; i++) {
/*  81 */       this.baselineOffsets[i] = this.baselineOffsets[i] * scaleFactor;
/*     */     }
/*  83 */     this.descent = lineMetrics.getDescent() * scaleFactor;
/*  84 */     this.height = lineMetrics.getHeight() * scaleFactor;
/*  85 */     this.leading = lineMetrics.getLeading();
/*  86 */     this.numChars = lineMetrics.getNumChars();
/*  87 */     this.strikethroughOffset = lineMetrics.getStrikethroughOffset() * scaleFactor;
/*     */     
/*  89 */     this.strikethroughThickness = lineMetrics.getStrikethroughThickness() * scaleFactor;
/*     */     
/*  91 */     this.underlineOffset = lineMetrics.getUnderlineOffset() * scaleFactor;
/*  92 */     this.underlineThickness = lineMetrics.getUnderlineThickness() * scaleFactor;
/*     */     
/*  94 */     this.overlineOffset = -this.ascent;
/*  95 */     this.overlineThickness = this.underlineThickness;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GVTLineMetrics(float ascent, int baselineIndex, float[] baselineOffsets, float descent, float height, float leading, int numChars, float strikethroughOffset, float strikethroughThickness, float underlineOffset, float underlineThickness, float overlineOffset, float overlineThickness) {
/* 115 */     this.ascent = ascent;
/* 116 */     this.baselineIndex = baselineIndex;
/* 117 */     this.baselineOffsets = baselineOffsets;
/* 118 */     this.descent = descent;
/* 119 */     this.height = height;
/* 120 */     this.leading = leading;
/* 121 */     this.numChars = numChars;
/* 122 */     this.strikethroughOffset = strikethroughOffset;
/* 123 */     this.strikethroughThickness = strikethroughThickness;
/* 124 */     this.underlineOffset = underlineOffset;
/* 125 */     this.underlineThickness = underlineThickness;
/* 126 */     this.overlineOffset = overlineOffset;
/* 127 */     this.overlineThickness = overlineThickness;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 134 */   public float getAscent() { return this.ascent; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 141 */   public int getBaselineIndex() { return this.baselineIndex; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 149 */   public float[] getBaselineOffsets() { return this.baselineOffsets; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 156 */   public float getDescent() { return this.descent; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 163 */   public float getHeight() { return this.height; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 170 */   public float getLeading() { return this.leading; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 178 */   public int getNumChars() { return this.numChars; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 185 */   public float getStrikethroughOffset() { return this.strikethroughOffset; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 192 */   public float getStrikethroughThickness() { return this.strikethroughThickness; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 199 */   public float getUnderlineOffset() { return this.underlineOffset; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 206 */   public float getUnderlineThickness() { return this.underlineThickness; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 213 */   public float getOverlineOffset() { return this.overlineOffset; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 220 */   public float getOverlineThickness() { return this.overlineThickness; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\font\GVTLineMetrics.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */