/*     */ package org.apache.batik.gvt.font;
/*     */ 
/*     */ import java.util.Arrays;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Kern
/*     */ {
/*     */   private int[] firstGlyphCodes;
/*     */   private int[] secondGlyphCodes;
/*     */   private UnicodeRange[] firstUnicodeRanges;
/*     */   private UnicodeRange[] secondUnicodeRanges;
/*     */   private float kerningAdjust;
/*     */   
/*     */   public Kern(int[] firstGlyphCodes, int[] secondGlyphCodes, UnicodeRange[] firstUnicodeRanges, UnicodeRange[] secondUnicodeRanges, float adjustValue) {
/*  61 */     this.firstGlyphCodes = firstGlyphCodes;
/*  62 */     this.secondGlyphCodes = secondGlyphCodes;
/*  63 */     this.firstUnicodeRanges = firstUnicodeRanges;
/*  64 */     this.secondUnicodeRanges = secondUnicodeRanges;
/*  65 */     this.kerningAdjust = adjustValue;
/*     */     
/*  67 */     if (firstGlyphCodes != null)
/*  68 */       Arrays.sort(this.firstGlyphCodes); 
/*  69 */     if (secondGlyphCodes != null) {
/*  70 */       Arrays.sort(this.secondGlyphCodes);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean matchesFirstGlyph(int glyphCode, String glyphUnicode) {
/*  83 */     if (this.firstGlyphCodes != null) {
/*  84 */       int pt = Arrays.binarySearch(this.firstGlyphCodes, glyphCode);
/*  85 */       if (pt >= 0) return true; 
/*     */     } 
/*  87 */     if (glyphUnicode.length() < 1) return false; 
/*  88 */     char glyphChar = glyphUnicode.charAt(0);
/*  89 */     for (int i = 0; i < this.firstUnicodeRanges.length; i++) {
/*  90 */       if (this.firstUnicodeRanges[i].contains(glyphChar))
/*  91 */         return true; 
/*     */     } 
/*  93 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean matchesFirstGlyph(int glyphCode, char glyphUnicode) {
/* 106 */     if (this.firstGlyphCodes != null) {
/* 107 */       int pt = Arrays.binarySearch(this.firstGlyphCodes, glyphCode);
/* 108 */       if (pt >= 0) return true; 
/*     */     } 
/* 110 */     for (int i = 0; i < this.firstUnicodeRanges.length; i++) {
/* 111 */       if (this.firstUnicodeRanges[i].contains(glyphUnicode))
/* 112 */         return true; 
/*     */     } 
/* 114 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean matchesSecondGlyph(int glyphCode, String glyphUnicode) {
/* 128 */     if (this.secondGlyphCodes != null) {
/* 129 */       int pt = Arrays.binarySearch(this.secondGlyphCodes, glyphCode);
/* 130 */       if (pt >= 0) return true; 
/*     */     } 
/* 132 */     if (glyphUnicode.length() < 1) return false; 
/* 133 */     char glyphChar = glyphUnicode.charAt(0);
/* 134 */     for (int i = 0; i < this.secondUnicodeRanges.length; i++) {
/* 135 */       if (this.secondUnicodeRanges[i].contains(glyphChar))
/* 136 */         return true; 
/*     */     } 
/* 138 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean matchesSecondGlyph(int glyphCode, char glyphUnicode) {
/* 152 */     if (this.secondGlyphCodes != null) {
/* 153 */       int pt = Arrays.binarySearch(this.secondGlyphCodes, glyphCode);
/* 154 */       if (pt >= 0) return true; 
/*     */     } 
/* 156 */     for (int i = 0; i < this.secondUnicodeRanges.length; i++) {
/* 157 */       if (this.secondUnicodeRanges[i].contains(glyphUnicode))
/* 158 */         return true; 
/*     */     } 
/* 160 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 170 */   public float getAdjustValue() { return this.kerningAdjust; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\font\Kern.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */