/*     */ package org.apache.batik.gvt.text;
/*     */ 
/*     */ import java.text.AttributedCharacterIterator;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AttributedCharacterSpanIterator
/*     */   implements AttributedCharacterIterator
/*     */ {
/*     */   private AttributedCharacterIterator aci;
/*     */   private int begin;
/*     */   private int end;
/*     */   
/*     */   public AttributedCharacterSpanIterator(AttributedCharacterIterator aci, int start, int stop) {
/*  53 */     this.aci = aci;
/*  54 */     this.end = Math.min(aci.getEndIndex(), stop);
/*  55 */     this.begin = Math.max(aci.getBeginIndex(), start);
/*  56 */     this.aci.setIndex(this.begin);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  65 */   public Set getAllAttributeKeys() { return this.aci.getAllAttributeKeys(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  74 */   public Object getAttribute(AttributedCharacterIterator.Attribute attribute) { return this.aci.getAttribute(attribute); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  82 */   public Map getAttributes() { return this.aci.getAttributes(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  91 */   public int getRunLimit() { return Math.min(this.aci.getRunLimit(), this.end); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 100 */   public int getRunLimit(AttributedCharacterIterator.Attribute attribute) { return Math.min(this.aci.getRunLimit(attribute), this.end); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 109 */   public int getRunLimit(Set attributes) { return Math.min(this.aci.getRunLimit(attributes), this.end); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 117 */   public int getRunStart() { return Math.max(this.aci.getRunStart(), this.begin); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 127 */   public int getRunStart(AttributedCharacterIterator.Attribute attribute) { return Math.max(this.aci.getRunStart(attribute), this.begin); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 137 */   public int getRunStart(Set attributes) { return Math.max(this.aci.getRunStart(attributes), this.begin); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 146 */   public Object clone() { return new AttributedCharacterSpanIterator((AttributedCharacterIterator)this.aci.clone(), this.begin, this.end); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 156 */   public char current() { return this.aci.current(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 165 */   public char first() { return this.aci.setIndex(this.begin); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 173 */   public int getBeginIndex() { return this.begin; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 181 */   public int getEndIndex() { return this.end; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 189 */   public int getIndex() { return this.aci.getIndex(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 198 */   public char last() { return setIndex(this.end - 1); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public char next() {
/* 207 */     if (getIndex() < this.end - 1) {
/* 208 */       return this.aci.next();
/*     */     }
/* 210 */     return setIndex(this.end);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public char previous() {
/* 220 */     if (getIndex() > this.begin) {
/* 221 */       return this.aci.previous();
/*     */     }
/* 223 */     return Character.MAX_VALUE;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public char setIndex(int position) {
/* 234 */     int ndx = Math.max(position, this.begin);
/* 235 */     ndx = Math.min(ndx, this.end);
/* 236 */     char c = this.aci.setIndex(ndx);
/* 237 */     if (ndx == this.end) {
/* 238 */       c = Character.MAX_VALUE;
/*     */     }
/* 240 */     return c;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\text\AttributedCharacterSpanIterator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */