/*     */ package org.apache.batik.gvt.text;
/*     */ 
/*     */ import java.text.AttributedCharacterIterator;
/*     */ import java.text.AttributedString;
/*     */ import java.text.CharacterIterator;
/*     */ import java.text.StringCharacterIterator;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GVTACIImpl
/*     */   implements GVTAttributedCharacterIterator
/*     */ {
/*     */   private String simpleString;
/*     */   private Set allAttributes;
/*     */   private ArrayList mapList;
/*  50 */   private static int START_RUN = 2;
/*  51 */   private static int END_RUN = 3;
/*  52 */   private static int MID_RUN = 1;
/*  53 */   private static int SINGLETON = 0;
/*     */   public GVTACIImpl() {
/*  55 */     this.iter = null;
/*  56 */     this.currentIndex = -1;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  63 */     this.simpleString = "";
/*  64 */     buildAttributeTables();
/*     */   }
/*     */   private int[] charInRun;
/*     */   private CharacterIterator iter;
/*     */   private int currentIndex;
/*     */   
/*     */   public GVTACIImpl(AttributedCharacterIterator aci) {
/*     */     this.iter = null;
/*     */     this.currentIndex = -1;
/*  73 */     buildAttributeTables(aci);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setString(String s) {
/*  80 */     this.simpleString = s;
/*  81 */     this.iter = new StringCharacterIterator(this.simpleString);
/*  82 */     buildAttributeTables();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setString(AttributedString s) {
/*  89 */     this.iter = s.getIterator();
/*  90 */     buildAttributeTables((AttributedCharacterIterator)this.iter);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setAttributeArray(GVTAttributedCharacterIterator.TextAttribute attr, Object[] attValues, int beginIndex, int endIndex) {
/* 110 */     beginIndex = Math.max(beginIndex, 0);
/* 111 */     endIndex = Math.min(endIndex, this.simpleString.length());
/* 112 */     if (this.charInRun[beginIndex] == END_RUN) {
/* 113 */       if (this.charInRun[beginIndex - 1] == MID_RUN) {
/* 114 */         this.charInRun[beginIndex - 1] = END_RUN;
/*     */       } else {
/* 116 */         this.charInRun[beginIndex - 1] = SINGLETON;
/*     */       } 
/*     */     }
/* 119 */     if (this.charInRun[endIndex + 1] == END_RUN) {
/* 120 */       this.charInRun[endIndex + 1] = SINGLETON;
/* 121 */     } else if (this.charInRun[endIndex + 1] == MID_RUN) {
/* 122 */       this.charInRun[endIndex + 1] = START_RUN;
/*     */     } 
/* 124 */     for (int i = beginIndex; i <= endIndex; i++) {
/* 125 */       this.charInRun[i] = SINGLETON;
/* 126 */       int n = Math.min(i, attValues.length - 1);
/* 127 */       ((Map)this.mapList.get(i)).put(attr, attValues[n]);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 137 */   public Set getAllAttributeKeys() { return this.allAttributes; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 146 */   public Object getAttribute(AttributedCharacterIterator.Attribute attribute) { return getAttributes().get(attribute); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 154 */   public Map getAttributes() { return (Map)this.mapList.get(this.currentIndex); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getRunLimit() {
/* 163 */     int ndx = this.currentIndex;
/*     */     do {
/* 165 */       ndx++;
/* 166 */     } while (this.charInRun[ndx] == MID_RUN);
/* 167 */     return ndx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getRunLimit(AttributedCharacterIterator.Attribute attribute) {
/* 176 */     int ndx = this.currentIndex;
/* 177 */     Object value = getAttributes().get(attribute);
/*     */ 
/*     */     
/* 180 */     if (value == null) {
/*     */       do {
/* 182 */         ndx++;
/* 183 */       } while (((Map)this.mapList.get(ndx)).get(attribute) == null);
/*     */     } else {
/*     */       do {
/* 186 */         ndx++;
/* 187 */       } while (value.equals(((Map)this.mapList.get(ndx)).get(attribute)));
/*     */     } 
/* 189 */     return ndx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getRunLimit(Set attributes) {
/* 199 */     int ndx = this.currentIndex;
/*     */     do {
/* 201 */       ndx++;
/* 202 */     } while (attributes.equals(this.mapList.get(ndx)));
/* 203 */     return ndx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getRunStart() {
/* 211 */     int ndx = this.currentIndex;
/* 212 */     for (; this.charInRun[ndx] == MID_RUN; ndx--);
/* 213 */     return ndx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getRunStart(AttributedCharacterIterator.Attribute attribute) {
/* 223 */     int ndx = this.currentIndex - 1;
/* 224 */     Object value = getAttributes().get(attribute);
/*     */ 
/*     */     
/*     */     try {
/* 228 */       if (value == null) {
/* 229 */         while (((Map)this.mapList.get(ndx - true)).get(attribute) == null)
/* 230 */           ndx--; 
/*     */       } else {
/* 232 */         while (value.equals(((Map)this.mapList.get(ndx - 1)).get(attribute)))
/*     */         {
/* 234 */           ndx--; } 
/*     */       } 
/* 236 */     } catch (IndexOutOfBoundsException e) {}
/*     */     
/* 238 */     return ndx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getRunStart(Set attributes) {
/* 248 */     int ndx = this.currentIndex;
/*     */     try {
/* 250 */       for (; attributes.equals(this.mapList.get(ndx - 1)); ndx--);
/* 251 */     } catch (IndexOutOfBoundsException e) {}
/*     */     
/* 253 */     return ndx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 262 */   public Object clone() { return new GVTACIImpl(this); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 273 */   public char current() { return this.iter.current(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 282 */   public char first() { return this.iter.first(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 290 */   public int getBeginIndex() { return this.iter.getBeginIndex(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 298 */   public int getEndIndex() { return this.iter.getEndIndex(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 306 */   public int getIndex() { return this.iter.getIndex(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 315 */   public char last() { return this.iter.last(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 324 */   public char next() { return this.iter.next(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 333 */   public char previous() { return this.iter.previous(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 343 */   public char setIndex(int position) { return this.iter.setIndex(position); }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void buildAttributeTables() {
/* 349 */     this.allAttributes = new HashSet();
/* 350 */     this.mapList = new ArrayList(this.simpleString.length());
/* 351 */     this.charInRun = new int[this.simpleString.length()];
/* 352 */     for (int i = 0; i < this.charInRun.length; i++) {
/* 353 */       this.charInRun[i] = SINGLETON;
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 358 */       this.mapList.set(i, new HashMap());
/*     */     } 
/*     */   }
/*     */   
/*     */   private void buildAttributeTables(AttributedCharacterIterator aci) {
/* 363 */     this.allAttributes = aci.getAllAttributeKeys();
/* 364 */     int length = aci.getEndIndex() - aci.getBeginIndex();
/* 365 */     this.mapList = new ArrayList(length);
/* 366 */     this.charInRun = new int[length];
/* 367 */     char c = aci.first();
/* 368 */     char[] chars = new char[length];
/* 369 */     for (int i = 0; i < length; i++) {
/* 370 */       chars[i] = c;
/* 371 */       this.charInRun[i] = SINGLETON;
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 376 */       this.mapList.set(i, new HashMap(aci.getAttributes()));
/* 377 */       c = aci.next();
/*     */     } 
/* 379 */     this.simpleString = new String(chars);
/*     */   }
/*     */ 
/*     */   
/*     */   public class TransformAttributeFilter
/*     */     implements GVTAttributedCharacterIterator.AttributeFilter
/*     */   {
/*     */     private final GVTACIImpl this$0;
/*     */ 
/*     */     
/* 389 */     public TransformAttributeFilter(GVTACIImpl this$0) { this.this$0 = this$0; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 400 */     public AttributedCharacterIterator mutateAttributes(AttributedCharacterIterator aci) { return aci; }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\text\GVTACIImpl.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */