/*     */ package org.apache.batik.gvt.flow;
/*     */ 
/*     */ import org.apache.batik.gvt.font.GVTGlyphVector;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class GlyphGroupInfo
/*     */ {
/*     */   int start;
/*     */   int end;
/*     */   int glyphCount;
/*     */   int lastGlyphCount;
/*     */   boolean hideLast;
/*     */   float advance;
/*     */   float lastAdvance;
/*     */   int range;
/*     */   GVTGlyphVector gv;
/*     */   boolean[] hide;
/*     */   
/*     */   public GlyphGroupInfo(GVTGlyphVector gv, int start, int end, boolean[] glyphHide, boolean glyphGroupHideLast, float[] glyphPos, float[] advAdj, float[] lastAdvAdj, boolean[] space) {
/*  50 */     this.gv = gv;
/*  51 */     this.start = start;
/*  52 */     this.end = end;
/*  53 */     this.hide = new boolean[this.end - this.start + 1];
/*  54 */     this.hideLast = glyphGroupHideLast;
/*  55 */     System.arraycopy(glyphHide, this.start, this.hide, 0, this.hide.length);
/*     */ 
/*     */     
/*  58 */     float adv = glyphPos[2 * end + 2] - glyphPos[2 * start];
/*  59 */     float ladv = adv;
/*  60 */     adv += advAdj[end];
/*  61 */     int glyphCount = end - start + 1;
/*  62 */     for (int g = start; g < end; g++) {
/*  63 */       if (glyphHide[g]) glyphCount--; 
/*     */     } 
/*  65 */     int lastGlyphCount = glyphCount;
/*  66 */     for (int g = end; g >= start; g--) {
/*  67 */       ladv += lastAdvAdj[g];
/*  68 */       if (!space[g])
/*  69 */         break;  lastGlyphCount--;
/*     */     } 
/*  71 */     if (this.hideLast) lastGlyphCount--;
/*     */     
/*  73 */     this.glyphCount = glyphCount;
/*  74 */     this.lastGlyphCount = lastGlyphCount;
/*  75 */     this.advance = adv;
/*  76 */     this.lastAdvance = ladv;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  82 */   public GVTGlyphVector getGlyphVector() { return this.gv; }
/*     */ 
/*     */   
/*  85 */   public int getStart() { return this.start; }
/*     */   
/*  87 */   public int getEnd() { return this.end; }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  92 */   public int getGlyphCount() { return this.glyphCount; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  98 */   public int getLastGlyphCount() { return this.lastGlyphCount; }
/*     */   
/* 100 */   public boolean[] getHide() { return this.hide; }
/*     */ 
/*     */ 
/*     */   
/* 104 */   public boolean getHideLast() { return this.hideLast; }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 109 */   public float getAdvance() { return this.advance; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 117 */   public float getLastAdvance() { return this.lastAdvance; }
/*     */   
/* 119 */   public void setRange(int range) { this.range = range; }
/* 120 */   public int getRange() { return this.range; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\flow\GlyphGroupInfo.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */