/*     */ package org.apache.batik.gvt.font;
/*     */ 
/*     */ import java.awt.Font;
/*     */ import java.awt.font.TextAttribute;
/*     */ import java.text.AttributedCharacterIterator;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import org.apache.batik.gvt.text.GVTAttributedCharacterIterator;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AWTFontFamily
/*     */   implements GVTFontFamily
/*     */ {
/*  37 */   public static final AttributedCharacterIterator.Attribute TEXT_COMPOUND_DELIMITER = GVTAttributedCharacterIterator.TextAttribute.TEXT_COMPOUND_DELIMITER;
/*     */ 
/*     */ 
/*     */   
/*     */   protected GVTFontFace fontFace;
/*     */ 
/*     */ 
/*     */   
/*     */   protected Font font;
/*     */ 
/*     */ 
/*     */   
/*  49 */   public AWTFontFamily(GVTFontFace fontFace) { this.fontFace = fontFace; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  58 */   public AWTFontFamily(String familyName) { this(new GVTFontFace(familyName)); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public AWTFontFamily(GVTFontFace fontFace, Font font) {
/*  67 */     this.fontFace = fontFace;
/*  68 */     this.font = font;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  77 */   public String getFamilyName() { return this.fontFace.getFamilyName(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  84 */   public GVTFontFace getFontFace() { return this.fontFace; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GVTFont deriveFont(float size, AttributedCharacterIterator aci) {
/*  95 */     if (this.font != null) {
/*  96 */       return new AWTGVTFont(this.font, size);
/*     */     }
/*  98 */     return deriveFont(size, aci.getAttributes());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GVTFont deriveFont(float size, Map attrs) {
/* 108 */     if (this.font != null) {
/* 109 */       return new AWTGVTFont(this.font, size);
/*     */     }
/* 111 */     Map fontAttributes = new HashMap(attrs);
/* 112 */     fontAttributes.put(TextAttribute.SIZE, new Float(size));
/* 113 */     fontAttributes.put(TextAttribute.FAMILY, this.fontFace.getFamilyName());
/* 114 */     fontAttributes.remove(TEXT_COMPOUND_DELIMITER);
/* 115 */     return new AWTGVTFont(fontAttributes);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\font\AWTFontFamily.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */