/*     */ package org.apache.batik.gvt.renderer;
/*     */ 
/*     */ import java.awt.Graphics2D;
/*     */ import java.awt.Shape;
/*     */ import java.awt.font.FontRenderContext;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import org.apache.batik.gvt.TextNode;
/*     */ import org.apache.batik.gvt.TextPainter;
/*     */ import org.apache.batik.gvt.text.ConcreteTextLayoutFactory;
/*     */ import org.apache.batik.gvt.text.Mark;
/*     */ import org.apache.batik.gvt.text.TextHit;
/*     */ import org.apache.batik.gvt.text.TextLayoutFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class BasicTextPainter
/*     */   implements TextPainter
/*     */ {
/*  44 */   private static TextLayoutFactory textLayoutFactory = new ConcreteTextLayoutFactory();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  50 */   protected FontRenderContext fontRenderContext = new FontRenderContext(new AffineTransform(), true, true);
/*     */ 
/*     */   
/*  53 */   protected FontRenderContext aaOffFontRenderContext = new FontRenderContext(new AffineTransform(), false, true);
/*     */ 
/*     */ 
/*     */   
/*  57 */   protected TextLayoutFactory getTextLayoutFactory() { return textLayoutFactory; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  67 */   public Mark selectAt(double x, double y, TextNode node) { return hitTest(x, y, node); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Mark selectTo(double x, double y, Mark beginMark) {
/*  77 */     if (beginMark == null) {
/*  78 */       return null;
/*     */     }
/*  80 */     return hitTest(x, y, beginMark.getTextNode());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  91 */   public Rectangle2D getGeometryBounds(TextNode node) { return getOutline(node).getBounds2D(); }
/*     */   
/*     */   protected abstract Mark hitTest(double paramDouble1, double paramDouble2, TextNode paramTextNode);
/*     */   
/*     */   public abstract Rectangle2D getBounds2D(TextNode paramTextNode);
/*     */   
/*     */   public abstract Shape getOutline(TextNode paramTextNode);
/*     */   
/*     */   public abstract Shape getHighlightShape(Mark paramMark1, Mark paramMark2);
/*     */   
/*     */   public abstract int[] getSelected(Mark paramMark1, Mark paramMark2);
/*     */   
/*     */   public abstract Mark getMark(TextNode paramTextNode, int paramInt, boolean paramBoolean);
/*     */   
/*     */   public abstract Mark selectLast(TextNode paramTextNode);
/*     */   
/*     */   public abstract Mark selectFirst(TextNode paramTextNode);
/*     */   
/*     */   public abstract void paint(TextNode paramTextNode, Graphics2D paramGraphics2D);
/*     */   
/*     */   protected static class BasicMark implements Mark {
/*     */     private TextNode node;
/*     */     private TextHit hit;
/*     */     
/*     */     protected BasicMark(TextNode node, TextHit hit) {
/* 116 */       this.hit = hit;
/* 117 */       this.node = node;
/*     */     }
/*     */ 
/*     */     
/* 121 */     public TextHit getHit() { return this.hit; }
/*     */ 
/*     */ 
/*     */     
/* 125 */     public TextNode getTextNode() { return this.node; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 134 */     public int getCharIndex() { return this.hit.getCharIndex(); }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-gvt.jar!\org\apache\batik\gvt\renderer\BasicTextPainter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */